/*
 *	sybfront.h 77.1 11/11/91
 *
 *	Sybase DB-LIBRARY Version 4.0
 *	Confidential Property of Sybase, Inc.
 *	(c) Copyright Sybase, Inc. 1988, 1990
 *	All rights reserved
 *
 *
 * Use, duplication, or disclosure by the Government
 * is subject to restrictions as set forth in subparagraph (c) (1) (ii)
 * of the Rights in Technical Data and Computer Software clause
 * at DFARS 52.227-7013. Sybase, Inc. 6475 Christie Avenue, Emeryville,
 * CA 94608.
 *
 */

#ifndef	__sybfront__
#define	__sybfront__

#include <sybtypes.h>		/* DB-Library data types will be based on
				** the types in the common lib include file.
				*/

#define MAC	0		/* Mike, why this line ? */

#define KR_C_COMPILE	1
#define ANSI_C_COMPILE	2
#define	CPP_COMPILE	3

/*
**	Languages
*/

#define	SYB_C		0
#define	SYB_FORTRAN	1
#define	SYB_COBOL	2
#define SYB_ADA		3
#define	SYB_VERDIX_ADA	4
#define SYB_PASCAL	5
#define SYB_HYPERTALK	6
#define SYB_PL1		7

/*
**	Return types
*/

typedef int		RETCODE;	/* SUCCEED or FAIL */
typedef	int		STATUS;		/* OK or condition code */

#if	(MAC)
#define	STDEXIT		0
#define	ERREXIT		-1
#endif	/* (MAC) */

/* Some machines don't support void pointers. */
#if (SUNOS3 || AIX)
typedef char	*DBVOIDPTR;
#else
typedef void	*DBVOIDPTR;
#endif

#ifndef	NULL
#define NULL		0
#endif	/* NULL */

#ifndef FALSE
#define FALSE		0
#endif

#ifndef TRUE
#define TRUE		1
#endif

#define	SUCCEED		1
#define	FAIL		0

/*
**	Defines for exit
*/

#ifndef STDEXIT
#if !VMS
#define STDEXIT         0
#else
#define STDEXIT         1
#endif /* !VMS */
#endif  /*  ifndef STDEXIT  */

#ifndef ERREXIT
#if !VMS
#define ERREXIT         -1
#else
#include <stsdef.h>
#define ERREXIT STS$K_SEVERE | STS$M_INHIB_MSG
#endif /* !VMS */
#endif  /*  ifndef ERREXIT  */

/*
** 	Defines for the "answer" in interrupt pop-ups 
*/

#define INT_EXIT	0
#define INT_CONTINUE	1
#define INT_CANCEL	2
#define INT_TIMEOUT	3


/* DataServer variable typedefs - These are now based on the 
** definitions contained in common library 
*/
#define	DBTINYINT	COM_TINYINT	/* DataServer 1 byte integer */
#define DBSMALLINT	COM_SMALLINT	/* DataServer 2 byte integer */
#define	DBINT		COM_INT		/* DataServer 4 byte integer */
#define	DBCHAR		COM_CHAR	/* DataServer char type */
#define	DBBINARY	COM_BINARY	/* DataServer binary type */
#define DBBIT		COM_BIT		/* DataServer bit type */
#define DBDATETIME	COM_DATETIME	/* DataServer datetime type */	
#define DBDATETIME4	COM_DATETIME4	/* DataServer 4-byte datetime type */
#define DBMONEY		COM_MONEY	/* DataServer money type */
#define DBMONEY4	COM_MONEY4	/* DataServer 4-byte money type */
#define	DBFLT8		COM_FLT8	/* DataServer float type */
#define DBREAL		COM_REAL	/* 4-byte float type */

#define BYTE		COM_BYTE
#define DBBOOL		COM_BOOL 	/* Less likely to collide than "BOOL" */

/*	
**	Typedefs
*/

#ifndef	_OBJC_OBJC_H_			/* jjg 2/23/93 to prevent collision with objc.h */
typedef unsigned char	BOOL;		/* So older programs won't break yet */
#endif	_OBJC_OBJC_H_
typedef BYTE		*POINTER;

/*
**	Pointers to functions returning ...
*/

typedef	int		(*INTFUNCPTR)();
typedef	void		(*VOIDFUNCPTR)();
typedef	DBBOOL		(*BOOLFUNCPTR)();

#endif	/*__sybfront__*/
